
#include <iostream>
#include <vector>
using namespace std;

int lamps[1000002];

int main(){
	unsigned long long int a, b, c;
	unsigned long long int ab;
	
	for(a = 1; a <= 100ull; ++a){
		for(b = a + 1; b < 1000002ull; ++b){
			ab = a * b;
			for(c = b + 1; ab * c <= 1000000ull; ++c){
				if(ab * c < 0){
					cout << "BUG";
					return 0;
				}
				lamps[ab * c] ++;
			}
		}
	}
	
	for(size_t i = 1; i < 1000002; ++i){
		lamps[i] += lamps[i-1];
		if(lamps[i] < 0){
			cout << "BUG2";
		}
	}
	int N;
	cin >> N;
	
	for(int i = 0; i < N; ++i){
		cin >> b;
		cout << lamps[b] << std::endl;
	}
	
	
	return 0;
}
