#include <iostream>
#include <cstring>
using namespace std;
char arr[1001][1001];
char temp[1001][1001];
int val[1001][1001];
int numbers[1001];
int tnum[1001];
int N, M;
unsigned long long res = 0;

void copy() {
	memcpy(temp, arr, 1001*1001);
}

void zrcali(){
	for(int i = 0; i < N /2; ++i){
		for(int j = 0; j < M; ++j){
			swap(arr[i][j], arr[N-i - 1][j]);
		}
	}
}

void turn90() {
	for (int i = 0; i < N; i++) {
		for (int j = 0; j < M; j++) {
			temp[N - j - 1][i] = arr[i][j];
		}
	}
	
	swap(N, M);
	memcpy(arr, temp, 1001*1001);
}

int getTriangular(int x, int y) {
	int index = 1;
	int i, j;
	
	while (true) {
		i = x + index;
		j = y;
		
		if (i >= N && j + index >= M) {
			return index - 1;
		}
		
		while (i >= x) {
			if (temp[i][j] != temp[x][y]) {
				return index - 1;
			} else {
				i--; j++;	
			}
		}
		
		index++;
	}
}

void clear(int x, int y, int size) {
	while (size > 0) {
		for (int i = 0; i < size; ++i) {
			temp[x+i][y] = 0;
		}
		
		y++;
		size--;
	}
}

void check() {
	int size;
	
	for (int i = 0; i < N; i++) {
		for (int j = 0; j < M; j++) {
			if (temp[i][j] != 0) {
					size = getTriangular(i, j);
					if (size > 0) {
						cout << size << endl;
					}
					if(numbers[size] > val[i][j]){
						res += numbers[size] - val[i][j];
						val[i][j] = numbers[size];
					}
					clear(i, j, size);
			}
		}
	}
}

int main() {
	numbers[1] = 0;
	tnum[1] = 0;
	tnum[2] = 0;
	tnum[3] = 1;
	for (int i = 2; i < 1001; i++) {
			numbers[i] = numbers[i-1] + (i - 1);
	}
	for(int i = 1; i < 1001; ++i)
		numbers[i] += numbers[i-1];
		
	for(int i = 4; i < 1001; ++i){
		tnum[i] = tnum[i -1] + 2 * (i - 3);
	}
	for(int i = 0; i < 1001; ++i)
		numbers[i] += tnum[i];
	
	for(int i = 0; i < 10; ++i){
		cout << numbers[i] << ' ';
	}
	cout << endl;
	for(int i = 0; i < 10; ++i){
		cout << tnum[i] << ' ';
	}
	cout << endl;
	cin >> N >> M;
	
	for (int i = 0; i < N; i++) {
			for (int j = 0; j < M; j++) {
				cin >> arr[i][j];
				//cout << arr[i][j] << " ";
			}
			//cout << endl;
	}
	
	//cout << "OK";
	copy();
	check();
	memcpy(arr, temp, 1001*1001);
	
	for (int i = 0; i < 3; i++) {
		turn90();
		check();
		memcpy(arr, temp, 1001*1001);
	}
	
	zrcali();
	copy();
	check();
	memcpy(arr, temp, 1001*1001);
	
	for (int i = 0; i < 3; i++) {
		turn90();
		check();
		memcpy(arr, temp, 1001*1001);
	}
	
	cout << res;
	
	
	return 0;
}
